/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.InetAddressBinding;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.SessionRecord;

import java.net.InetAddress;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Session extends TableImpl<SessionRecord> {

	private static final long serialVersionUID = -1691588194;

	/**
	 * The reference instance of <code>public.session</code>
	 */
	public static final Session SESSION = new Session();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<SessionRecord> getRecordType() {
		return SessionRecord.class;
	}

	/**
	 * The column <code>public.session.id</code>.
	 */
	public final TableField<SessionRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.session.client_uid</code>.
	 */
	public final TableField<SessionRecord, String> CLIENT_UID = createField("client_uid", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.session.user_name</code>.
	 */
	public final TableField<SessionRecord, String> USER_NAME = createField("user_name", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.session.group</code>.
	 */
	public final TableField<SessionRecord, String> GROUP = createField("group", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.session.ip</code>.
	 */
	public final TableField<SessionRecord, InetAddress> IP = createField("ip", org.jooq.impl.DefaultDataType.getDefaultDataType("inet"), this, "", new InetAddressBinding());

	/**
	 * The column <code>public.session.start_time</code>.
	 */
	public final TableField<SessionRecord, Date> START_TIME = createField("start_time", org.jooq.impl.SQLDataType.TIMESTAMP, this, "", new DateConverter());

	/**
	 * The column <code>public.session.end_time</code>.
	 */
	public final TableField<SessionRecord, Date> END_TIME = createField("end_time", org.jooq.impl.SQLDataType.TIMESTAMP, this, "", new DateConverter());

	/**
	 * The column <code>public.session.last_access_time</code>.
	 */
	public final TableField<SessionRecord, Date> LAST_ACCESS_TIME = createField("last_access_time", org.jooq.impl.SQLDataType.TIMESTAMP, this, "", new DateConverter());

	/**
	 * Create a <code>public.session</code> table reference
	 */
	public Session() {
		this("session", null);
	}

	/**
	 * Create an aliased <code>public.session</code> table reference
	 */
	public Session(String alias) {
		this(alias, SESSION);
	}

	private Session(String alias, Table<SessionRecord> aliased) {
		this(alias, aliased, null);
	}

	private Session(String alias, Table<SessionRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<SessionRecord, Long> getIdentity() {
		return Keys.IDENTITY_SESSION;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<SessionRecord> getPrimaryKey() {
		return Keys.SESSION_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<SessionRecord>> getKeys() {
		return Arrays.<UniqueKey<SessionRecord>>asList(Keys.SESSION_PKEY, Keys.SESSION_CLIENT_UID_KEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Session as(String alias) {
		return new Session(alias, this);
	}

	/**
	 * Rename this table
	 */
	public Session rename(String name) {
		return new Session(name, null);
	}
}
